\addchap{Changelog}


To check which version of \maniFEM{} is installed in your computer, see at the beginning
of the file {\small\tt maniFEM.h}.


% \section*{21.04}

% \noindent Finite elements, rudimentary use.

% \section*{21.06}

% \noindent Change syntax of iterators.

% \noindent Introduce different types of meshes\,:
% {\small\tt\verm{Mesh}::Fuzzy} keep lists of cells,
% {\small\tt\verm{Mesh}::Connected::OneDim} only keep first and last vertices,
% paragraph \ref{\numb section 12.\numb parag 6}.

% \noindent Introduce garbage collectors (not fully working for cells and meshes).

% \section*{21.07}

% \noindent Garbage collectors for cells and meshes work,
% paragraph \ref{\numb section 12.\numb parag 5}.

% \noindent Introduce iterators around a cell, paragraph \ref{\numb section 9.\numb parag 10}.

% \noindent Some examples about remeshing, section \ref{\numb section 10}.

% \section*{21.08}

% \noindent Minor improvements and bug fixes, particularly a bug in progressive mesh generation.

% \section*{21.09}

% \noindent Some examples of quotient manifolds.

% \section*{21.11}

% \noindent Folding (or wrapping) of a mesh around a cylinder or a torus, paragraphs
% \ref{\numb section 7.\numb parag 19}\,--\,\ref{\numb section 7.\numb parag 22}.

% \section*{21.12}

% \noindent Change {\small\tt spin} into {\small\tt winding}.
% Cone-like quotient manifolds, paragraphs \ref{\numb section 7.\numb parag 15} and
% \ref{\numb section 7.\numb parag 16}.

% \noindent Change {\small\tt\verm{CellIterator}} to {\small\tt\verm{Mesh}::Iterator},
% thus exposing one less name in {\small\tt namespace \verm{maniFEM}}.

% \noindent Fast (hand-coded) finite elements, paragraphs \ref{\numb section 11.\numb parag 11}
% and \ref{\numb section 11.\numb parag 12}.


\section*{22.01}

\noindent Lagrange finite elements of degree two, paragraphs \ref{\numb section 11.\numb parag 5}\,%
--\,\ref{\numb section 11.\numb parag 8}.


\section*{22.02}

\noindent In progressive mesh generation (section \ref{\numb section 3}), change
{\small\tt\taag::inherent\_\,orientation} into
{\small\tt\taag::} {\small\tt::orientation,} {\small\tt\taag::inherent} etc.
Introduce {\small\tt\taag::shortest\_\,path}.

\noindent Introduce constructor {\small\tt\verm{Mesh}} {\small\tt \azul{msh}} {\small\tt (}
{\small\tt\taag::import,} {\small\tt \taag::msh,}
{\small\tt\verde{"filename.msh"})}.
\noindent Rename {\small\tt\verm{Mesh}::} {\small\tt::export\_\,msh} to
{\small\tt\verm{Mesh}::export\_\,to\_\,file}.
Switch to {\small\tt gmsh} version 4 format.          

\noindent Introduce constructor {\small\tt\verm{Mesh}} {\small\tt \azul{msh}} {\small\tt (}
{\small\tt\taag::cube,} {\small\tt ...} {\small\tt )}, paragraphs
\ref{\numb section 1.\numb parag 7}, \ref{\numb section 2.\numb parag 15} and
\ref{\numb section 2.\numb parag 18}.

\noindent Gather source files under {\small\tt src} directory.


\section*{22.03}

\noindent Fix nasty bug in progressive mesh generation.
Still not entirely stable, needs more work.

\noindent 3D torus, made of cubic cells, paragraphs \ref{\numb section 7.\numb parag 11}\,--\,%
\ref{\numb section 7.\numb parag 13}.

\noindent {\small\tt\verm{Cell}} constructor with {\small\tt\taag::vertex},
{\small\tt\taag::of\_\,coords}, {\small\tt\taag::project}.

\noindent Zero-dimensional {\small\tt\verm{Manifold}}\hglue0.5pt s, paragraphs
\ref{\numb section 2.\numb parag 14} and \ref{\numb section 7.\numb parag 11}.

\noindent Change {\small\tt\taag::progressive} into {\small\tt\taag::frontal}.

\noindent STSI meshes work in an incipient setting.


\section*{22.04}

\noindent Specific garbage collector implemented for
{\small\tt\verm{FiniteElement}}\hglue0.5pt s and {\small\tt\verm{Integrator}}\hglue0.5pt s.
We can declare and use an integrator without bothering with the subjacent finite element,
paragraphs \ref{\numb section 1.\numb parag 1} and \ref{\numb section 6.\numb parag 2}.

\noindent Add {\small\tt\verm{Mesh}} constructor with {\small\tt\taag::quadrangle},
{\small\tt\taag::winding}, {\small\tt\taag::singular},
in the spirit of paragraph \ref{\numb section 7.\numb parag 16}.


\section*{22.05}

\noindent Multifunctions,
paragraphs \ref{\numb section 7.\numb parag 27}\,--\,\ref{\numb section 7.\numb parag 31}.

\noindent Intersection of {\small\tt\verm{Manifold}}\hglue0.5pt s,
paragraphs \ref{\numb section 2.\numb parag 14}, \ref{\numb section 3.\numb parag 17},
\ref{\numb section 3.\numb parag 18}, \ref{\numb section 3.\numb parag 19}.

\noindent Overlapping meshes, paragraph \ref{\numb section 3.\numb parag 20}.
\vfil\eject


\section*{22.08}

\noindent Migrate from {\tt github.com} to {\tt codeberg.org}.

\noindent New implementation of frontal mesh generation, more robust and easier to generalize for
quotient manifolds and for 3D meshing.

\noindent Anisotropic Riemann metric, paragraph \ref{\numb section 3.\numb parag 27}.

\noindent Frontal meshing on quotient manifolds, paragraphs \ref{\numb section 7.\numb parag 23}\,--\,%
\ref{\numb section 7.\numb parag 26}.


\section*{22.09}

\noindent Declare the {\small\tt\verm{MetricTree}} with the trivial Euclidian distance on
$ {\mathbb R}^n $, even if we work on a submanifold of $ {\mathbb R}^n $ with a different Riemann metric,
paragraph \ref{\numb section 13.\numb parag 15}.
Rescale each call to {\small\tt find\_\,close\_\,neighbours\_\,of} if the metric is isotropic,
paragraphs \ref{\numb section 3.\numb parag 23}\,--\,\ref{\numb section 3.\numb parag 26}.
Use the inner spectral radius if the metric is anisotropic,
paragraphs \ref{\numb section 3.\numb parag 27}\,--\,\ref{\numb section 3.\numb parag 30}.

\noindent Hide name {\small\tt Field} into namespace {\small\tt\taag::Util}.


\section*{23.10}

\noindent Implement frontal meshing with tetrahedra.

\noindent Many changes in {\small\tt frontal.cpp} not visible to the final user.
In the case of co-dimension one, the normals are propagated from each segment to neighbour segments.
In the pure 2D case, the normal is obtained simply by rotation of the segment.
In the pure 3D case, the normal is computed by rescaling the exterior product of two segments.
Anisotropic metrics are given a special treatment.

\section*{23.11}

\noindent Fix bugs in frontal mesh generation with tetrahedra.

\noindent Implement class {\small\tt\verm{Mesh}::Composite}, section \ref{\numb section 5}.


\section*{24.02}

\noindent Fix bugs in frontal mesh generation with tetrahedra.

\noindent Improve class {\small\tt\verm{Mesh}::Composite}.


\section*{24.03}

\noindent Fix bugs in frontal mesh generation with tetrahedra.


\section*{24.05}

\noindent Add tetrahedral finite elements, Lagrange P1.

\noindent Improve hand-coded integrators by using one {\small\tt std::array} instead of
nested {\small\tt std::vector}\hskip0.5pt s
as well as {\small\tt constexpr size\_\,t} indices,
hopefully allowing the compiler to produce code optimized for speed.

\noindent Change method {\small\tt\verm{Mesh}::draw\_\,ps} to {\small\tt\verm{Mesh}::export\_\,to\_\,file}
with {\small\tt\taag::eps}.


\section*{24.06}

\noindent Implement Gauss quadrature on triangles with 7, 12 and 13 points.

\noindent Fix bug in hand-coded triangular finite elements.

\noindent Implement variational formulations and boundary conditions as {\tt C++} objects
(work in progress).


\section*{24.07}

\noindent {\small\tt\verm{VariationalFormulation}}\hglue0.5pt s work,
with Lagrange finite elements of degree 1,
see paragraphs \ref{\numb section 6.\numb parag 3} and \ref{\numb section 6.\numb parag 4}.


\section*{24.10}

\noindent Allow for concentrated loads in
{\small\tt\verm{VariationalFormulation}}\hglue 0.5 pt s,
see paragraph \ref{\numb section 6.\numb parag 5}.

\noindent In {\small\tt\verm{Manifold}}\hglue 0.5pt s, replace the naked pointer to the core
by a {\small\tt shared\_\,ptr}.

\noindent Change {\small\tt\verm{Cell}::add\hglue 0.5pt \_\hglue 0.5pt to\_\,mesh} to
{\small\tt add\hglue 0.5pt \_\hglue 0.5pt to},
{\small\tt\verm{Cell}::remove\_\,from\_\,mesh} to {\small\tt remove\_\,from}.

\noindent Change {\small\tt\taag::import} to {\small\tt\taag::import\hglue 0.5pt \_\,%
from\hglue 0.5pt \_\,file}.

\noindent Add hexahedral (parallelipiped, cube) finite elements,
paragraph \ref{\numb section 11.\numb parag 10}.

\noindent Implement reading a composite mesh and, at the same time,
the numbering of the vertices from the {\small\tt msh} file, paragraphs
\ref{\numb section 5.\numb parag 9} and \ref{\numb section 5.\numb parag 10}.


\section*{24.11}

\noindent Profound change in syntax of {\small\tt\verm{Mesh}} declaration.
{\small\tt\verm{Mesh}} constructors are replaced by a chain of
temporary {\small\tt\verm{Mesh}::Build} objects which hold information about the meshing options.
The {\small\tt\verm{Mesh}} constructor is invoked only upon conversion of the last
{\small\tt\verm{Mesh}::Build} object to {\small\tt\verm{Mesh}}.
See paragraph \ref{\numb section 12.\numb parag 8}.


\section*{24.12}

\noindent Implement {\small\tt\verm{Mesh}::Build}\,ers with {\small\tt\taag::grid}, from vertices.

\noindent Implement method {\small\tt\verm{Mesh}::boundary}.

\noindent Switch to {\tt C++} standard 23.

\noindent Implement extruding, section \ref{\numb section 4}.


\section*{25.01}

\noindent Implement more cases of extruding, section \ref{\numb section 4}.

\noindent Change in syntax of {\small\tt\verm{Mesh}::Build}\,ers with {\small\tt\taag::join}.

\noindent Extruding composite meshes.


\section*{25.02}

\noindent When extruding meshes, allow for a disconnected swatch.
Track must be connected.


\section*{To do}

\noindent Increase efficiency and stability of the frontal meshing algorithm with tetrahedra.
Implement post-processing for improving mesh quality.

\noindent Implement intersection of {\small\tt\verm{Mesh}}\hglue0.5pt es
(whose dimension depends on the way the two meshes touch).

\noindent Add more types of finite elements (lots of them).

\noindent High-dimensional connected meshes; iterators based on STSI meshes;
similar to, but simpler than, frontal mesh generation.

\noindent Define regions in a manifold (i.e.\ manifolds with boundary) by means of
inequalities between {\small\tt\verm{Function}}\hglue0.5pt s
(partially done, see methods {\small\tt\verm{Mesh}::unfold} and
{\small\tt\verm{Mesh}::export\_\,to\_\,file} with {\small\tt\taag::eps}, {\small\tt\taag::unfold}).

\noindent Implement frontal mesh generation with triangles for geometric dimension higher than three.

\noindent Implement locally Delaunay mesh generation, starting from a cloud of points.

\noindent Change syntax for defining iterators, allowing for multi-statement definitions.

\noindent Extend extruding for two-dimensional track.

\noindent There are case to be implemented of extruding meshes\,: 2D swatch with closed track,
composite meshes with 2d swatch.
